--  D:\BASYS_PROJECTS\SPEED_CONTROL\TOGGLE_STM1.vhd
--  VHDL code created by Xilinx's StateCAD 9.2i
--  Wed Oct 10 13:13:12 2007

--  This VHDL code (for use with Xilinx XST) was generated using: 
--  binary encoded state assignment with structured code format.
--  Minimization is enabled,  implied else is enabled, 
--  and outputs are speed optimized.

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY SHELL_TOGGLE_STM1 IS
	PORT (CLK,Button,RESET: IN std_logic;
		Q0,Q1,Q2 : OUT std_logic);
END;

ARCHITECTURE BEHAVIOR OF SHELL_TOGGLE_STM1 IS
	SIGNAL sreg : std_logic_vector (2 DOWNTO 0);
	SIGNAL next_sreg : std_logic_vector (2 DOWNTO 0);
	CONSTANT STATE0 : std_logic_vector (2 DOWNTO 0) :="000";
	CONSTANT STATE1 : std_logic_vector (2 DOWNTO 0) :="001";
	CONSTANT STATE2 : std_logic_vector (2 DOWNTO 0) :="010";
	CONSTANT STATE3 : std_logic_vector (2 DOWNTO 0) :="011";
	CONSTANT STATE4 : std_logic_vector (2 DOWNTO 0) :="100";
	CONSTANT STATE5 : std_logic_vector (2 DOWNTO 0) :="101";

	SIGNAL next_Shreg0,next_Shreg1,next_Shreg2,next_Shreg3 : std_logic;
	SIGNAL Q : std_logic_vector (2 DOWNTO 0);
	SIGNAL Shreg : std_logic_vector (3 DOWNTO 0);

	SIGNAL Res,Set,Shreg0,Shreg1,Shreg2,Shreg3: std_logic;
BEGIN
	PROCESS (CLK, next_Shreg0, next_Shreg1, next_Shreg2, next_Shreg3)
	BEGIN
		IF CLK='1' AND CLK'event THEN
			Shreg0 <= next_Shreg0;
			Shreg1 <= next_Shreg1;
			Shreg2 <= next_Shreg2;
			Shreg3 <= next_Shreg3;
		END IF;
	END PROCESS;

	PROCESS (CLK, next_sreg)
	BEGIN
		IF CLK='1' AND CLK'event THEN
			sreg <= next_sreg;
		END IF;
	END PROCESS;

	PROCESS (sreg,Res,RESET,Set,Q)
	BEGIN
		Q0 <= '0'; Q1 <= '0'; Q2 <= '0'; 
		Q<=std_logic_vector'("000"); 

		next_sreg<=STATE0;

		IF ( RESET='1' ) THEN
			next_sreg<=STATE0;

			Q <= (std_logic_vector'("000"));
		ELSE
			CASE sreg IS
				WHEN STATE0 =>
					Q <= (std_logic_vector'("000"));
					IF ( Set='1' ) THEN
						next_sreg<=STATE1;
					 ELSE
						next_sreg<=STATE0;
					END IF;
				WHEN STATE1 =>
					Q <= (std_logic_vector'("111"));
					next_sreg<=STATE2;
				WHEN STATE2 =>
					Q <= (std_logic_vector'("110"));
					IF ( Res='1' ) THEN
						next_sreg<=STATE3;
					 ELSE
						next_sreg<=STATE2;
					END IF;
				WHEN STATE3 =>
					Q <= (std_logic_vector'("100"));
					IF ( Set='1' ) THEN
						next_sreg<=STATE4;
					 ELSE
						next_sreg<=STATE3;
					END IF;
				WHEN STATE4 =>
					Q <= (std_logic_vector'("011"));
					next_sreg<=STATE5;
				WHEN STATE5 =>
					Q <= (std_logic_vector'("010"));
					IF ( Res='1' ) THEN
						next_sreg<=STATE0;
					 ELSE
						next_sreg<=STATE5;
					END IF;
				WHEN OTHERS =>
			END CASE;
		END IF;

		Q2 <= Q(2);
		Q1 <= Q(1);
		Q0 <= Q(0);
	END PROCESS;

	PROCESS (Button,Shreg1,Shreg2,Shreg3,Shreg)
	BEGIN
		Shreg <= (( std_logic_vector'(Button, Shreg3, Shreg2, Shreg1)));
		next_Shreg0 <= Shreg(0);
		next_Shreg1 <= Shreg(1);
		next_Shreg2 <= Shreg(2);
		next_Shreg3 <= Shreg(3);
	END PROCESS;

	PROCESS (Shreg0,Shreg1,Shreg2,Shreg3)
	BEGIN
		IF (( Shreg0='0' AND Shreg1='0' AND Shreg2='0' AND Shreg3='0' )) THEN 
			Res<='1';
		ELSE Res<='0';
		END IF;
	END PROCESS;

	PROCESS (Shreg0,Shreg1,Shreg2,Shreg3)
	BEGIN
		IF (( Shreg0='1' AND Shreg1='1' AND Shreg2='1' AND Shreg3='1' )) THEN 
			Set<='1';
		ELSE Set<='0';
		END IF;
	END PROCESS;
END BEHAVIOR;

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY TOGGLE_STM1 IS
	PORT (Q : OUT std_logic_vector (2 DOWNTO 0);
		CLK,Button,RESET: IN std_logic);
END;

ARCHITECTURE BEHAVIOR OF TOGGLE_STM1 IS
	COMPONENT SHELL_TOGGLE_STM1
		PORT (CLK,Button,RESET: IN std_logic;
			Q0,Q1,Q2 : OUT std_logic);
	END COMPONENT;
BEGIN
	SHELL1_TOGGLE_STM1 : SHELL_TOGGLE_STM1 PORT MAP (CLK=>CLK,Button=>Button,
		RESET=>RESET,Q0=>Q(0),Q1=>Q(1),Q2=>Q(2));
END BEHAVIOR;
